<div class="flex flex-col h-screen">
  <mat-card class="m-4">
    <mat-card-header class="m-2">
      <mat-card-title>
        <div class="flex">
          <button class="secondary-icon mr-3" (click)="back()"><mat-icon>keyboard_backspace</mat-icon></button>
        {{ clientName || "New Client" }}
        </div>
      </mat-card-title>
    </mat-card-header>
    <mat-card-content class="flex flex-col">
      <form [formGroup]="clientForm">
        <mat-form-field class="w-full">
          <mat-label>Client Name</mat-label>
          <input matInput formControlName="clientName" required>
          <mat-checkbox formControlName="isDisabled" matSuffix class="client-checkboxes">Disable Client</mat-checkbox>
          <mat-checkbox formControlName="isTrusted" matSuffix class="client-checkboxes">Trusted</mat-checkbox>
          <mat-checkbox formControlName="enforcePKCE" matSuffix class="client-checkboxes">Enforce PKCE</mat-checkbox>
          <mat-checkbox formControlName="autoApprove" matSuffix>Auto Approve</mat-checkbox>
        </mat-form-field>
        <p *ngIf="this.clientForm.controls.authenticationMethod.value === 'PUBLIC_CLIENT'" style="font-size: x-small; text-align: right; position: relative; line-height: 0;">*PKCE is Mandatory For Public Clients</p>
        <div class="w-full" style="margin-left: 1rem;" *ngIf="this.clientForm.controls.enforcePKCE.value">
          <mat-label>PKCE Code Challenge Methods: </mat-label>
          <mat-checkbox formControlName="allowPlain" matSuffix class="client-checkboxes">Plain</mat-checkbox>
          <mat-checkbox [disabled]="true" checked="true" matSuffix class="client-checkboxes">SHA 256</mat-checkbox>
        </div>
        <mat-form-field class="w-full">
          <mat-label>Authentication Method</mat-label>
          <mat-select [(value)]="authenticationMethod" formControlName="authenticationMethod"
             required>
            <mat-option *ngFor="let method of authMethods" [value]="method.value">
              {{ method.viewValue }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <mat-form-field class="w-full" *ngIf="clientId">
          <mat-label>Client ID</mat-label>
          <input matInput formControlName="clientId" password readonly>
        </mat-form-field>
        <mat-form-field class="w-full" *ngIf="clientSecret">
          <mat-label>Client Secret</mat-label>
          <input matInput formControlName="clientSecret"
            [type]="hideClientSecret ? 'password' : 'text'" readonly>
          <mat-icon matSuffix (click)="hideClientSecret = !hideClientSecret">
            {{hideClientSecret ? 'visibility' : 'visibility_off'}}
          </mat-icon>
        </mat-form-field>
        <mat-form-field class="w-full" *ngIf="changedClientSecret">
          <mat-label>Changed Client Secret</mat-label>
          <input matInput formControlName="changedClientSecret"
            [type]="hideChangedClientSecret ? 'password' : 'text'" readonly>
          <mat-icon matSuffix (click)="hideChangedClientSecret = !hideChangedClientSecret">
            {{hideChangedClientSecret ? 'visibility' : 'visibility_off'}}
          </mat-icon>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Scopes</mat-label>
          <mat-select formControlName="clientScopes" multiple required>
            <mat-option *ngFor="let scope of scopes" [value]="scope">{{scope}}</mat-option>
          </mat-select>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Custom Login Route</mat-label>
          <input matInput formControlName="customLoginRoute">
          <mat-hint>Relative to Authorization Server</mat-hint>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Token Delete Endoint</mat-label>
          <input matInput formControlName="tokenDeleteEndpoint">
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>User Delete Endpoint</mat-label>
          <input matInput formControlName="userDeleteEndpoint">
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Access Token Validity in Seconds</mat-label>
          <input matInput formControlName="accessTokenValidity" required>
          <mat-checkbox formControlName="restrictTokenUsage" matSuffix class="client-checkboxes">Restrict Token Usage</mat-checkbox>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Refresh Token Expires In Hours</mat-label>
          <input matInput formControlName="refreshTokenExpiresInHours" required>
          <mat-checkbox formControlName="is2FAMandated" matSuffix class="client-checkboxes">Enable 2FA</mat-checkbox>
          <mat-checkbox formControlName="revokeOnRefresh" matSuffix class="client-checkboxes">Revoke On Refresh</mat-checkbox>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Auth Code Expires In Minutes</mat-label>
          <input matInput formControlName="authCodeExpiresInMinutes" required>
        </mat-form-field>
        <div formArrayName="callbackURLForms"
          *ngFor="let url of clientForm.get('callbackURLForms')['controls']; let i = index;" style="width:100%">
          <div [formGroupName]="i">
            <mat-form-field class="w-1/2">
              <mat-label>Callback URL {{i+1}}</mat-label>
              <input matInput formControlName="callbackURL">
              <button mat-icon-button color="accent" matSuffix (click)="removeCallbackURL(i)">
                <mat-icon>close</mat-icon>
              </button>
            </mat-form-field>
          </div>
        </div>
        <button mat-button color="accent" (click)="addCallbackURL()">
          Add Redirect<mat-icon>add</mat-icon>
        </button>
      </form>
    </mat-card-content>
    <mat-card-actions class="m-4 flex flex-row gap-2">
      <button (click)="createClient()" mat-flat-button color="primary" [disabled]="!clientForm.valid"
        *ngIf="!clientId">Create</button>
      <button (click)="updateClient()" mat-flat-button color="primary" [disabled]="!clientForm.valid"
        *ngIf="clientId">Update</button>
      <button (click)="delete()" mat-flat-button color="warn" *ngIf="uuid !== new">Delete</button>
      <button mat-flat-button color="warn" *ngIf="uuid !== new" (click)="deleteClientToken()">Delete Bearer tokens</button>
    </mat-card-actions>
  </mat-card>
</div>
